﻿init -2 python:
    import renpy.store as store
    import renpy.exports as renpy
    import random
    from operator import attrgetter
    special_battle = False #for battles called outside of the dungeon
    
    encounter_chance = .8
    img_pref = "p_"
    move_keys_visible = True
    inv_page = 0
    
    # Create skills (name, hit, power)
    Slash = Skill("Slash", 70, 20)
    MiniSlash = Skill("Mini Slash", 70, 10)
    
    Punch = Skill("Punch", 80, 15)
    Kick = Skill("Kick", 60, 25)

    Bite = Skill("Bite", 80, 30)
    Scratch = Skill("Scratch", 100, 20)
    Charge = Skill("Charge", 60, 40)

    Shoot = Skill("Shoot", 100, 40, mp=15) #, "shoot")
    Defend = Skill("Defend", 0, 0, "defend")
    Inventory_sk = Skill("Inventory", 0, 0, "inventory")
    
    # Create battle actors (name, max_hp, skills)
    #player = Actor("Ten",100, [Punch, Kick, Shoot, Defend, Inventory], max_mp=50)
    #dog = Actor("Seconds",100, [Bite, Scratch, Charge, Defend])
    
    #Angel = Actor("Angel",666,[MiniSlash], image="angel laughing", weak="future")
    
    Future1 = Actor("Floating Corpse",40,[MiniSlash], image="enemy1_future", weak="future")
    Present1 = Actor("Floating Corpse",50,[MiniSlash], image="enemy1_present", weak="present")
    Past1 = Actor("Floating Corpse",60,[MiniSlash], image="enemy1_past", weak="past")
    Space1 = Actor("Floating Corpse",70,[MiniSlash], image="enemy1_space", weak="none")
    
    Future2 = Actor("Wraith",50,[MiniSlash], image="enemy2_future", weak="future")
    Present2 = Actor("Wraith",65,[MiniSlash], image="enemy2_present", weak="present")
    Past2 = Actor("Wraith",60,[MiniSlash], image="enemy2_past", weak="past")
    Space2 = Actor("Wraith",70,[MiniSlash], image="enemy2_space", weak="none")
    
    Future3 = Actor("Lost Soul",50,[MiniSlash,Slash], image="enemy3_future", weak="future")
    Present3 = Actor("Lost Soul",65,[MiniSlash,Slash], image="enemy3_present", weak="present")
    Past3 = Actor("Lost Soul",60,[MiniSlash,Slash], image="enemy3_past", weak="past")
    Space3 = Actor("Lost Soul",70,[MiniSlash,Slash], image="enemy3_space", weak="none")
    
    Future4 = Actor("Heatbreaker",50,[Slash], image="enemy4_future", weak="future")
    Present4 = Actor("Heatbreaker",65,[Slash], image="enemy4_present", weak="present")
    Past4 = Actor("Heatbreaker",60,[Slash], image="enemy4_past", weak="past")
    Space4 = Actor("Heatbreaker",70,[Slash], image="enemy4_space", weak="none")
    
    Future1b = Actor("Ghost",100,[MiniSlash,Slash], image="enemyb1_future", weak="future")
    Present1b = Actor("Ghost",110,[MiniSlash,Slash], image="enemyb1_present", weak="present")
    Past1b = Actor("Ghost",120,[MiniSlash,Slash], image="enemyb1_past", weak="past")
    Space1b = Actor("Ghost",130,[MiniSlash,Slash], image="enemyb1_space", weak="none")
    Future2b = Actor("Ghost",140,[Slash], image="enemyb2_future", weak="future")
    Present2b = Actor("Ghost",150,[Slash], image="enemyb2_present", weak="present")
    Past2b = Actor("Ghost",160,[Slash], image="enemyb2_past", weak="past")
    Space2b = Actor("Ghost",170,[Slash], image="enemyb2_space", weak="none")

    # Create maps. 1=wall, 2=exit, 3=entrance(entrance position must be also set in the script)

    #f1.
    stage1=[
    "1111111111",
    "1111011001",
    "1300000001",
    "1111111101",
    "1111011101",
    "120000a001",#a=event 1
    "1111111111",
    [] # Properties outside of a map can be used in random events. This is an encounter batttle event.
    ]
    
    stage1_1=[ #same as above, but no event
    "1111111111",
    "1111011001",
    "1300000001",
    "1111111101",
    "1111011101",
    "1200000001",
    "1111111111",
    []
    ]
    
    #pres1.
    stage2=[
    "111111",
    "130021",
    "111111",
    [Present1, Present2]
    ]
    
    #past1.
    stage3=[
    "1111111111",
    "1300000111",
    "1101011111",
    "1001021111",
    "1111011111",
    "1110001111",
    "1111111111",
    [Past1, Past2]
    ]
    
    #sp1.
    stage4=[
    "1111111111",
    "1101110111",
    "1000000301", #facing left
    "1101011101",
    "1111111201",
    "1111111111",
    [Space1, Space2]
    ]

    #f2. 
    stage5=[
    "1111111111",
    "1110111001",
    "1110100011",
    "1300001111",
    "1110100011",
    "1100011021",
    "1111111111",
    [Future1, Future2, Future3, Future4]
    ]
    
    #pres2.
    stage6=[
    "1111111111",
    "1100000001",
    "1301101101",
    "1100000001",
    "1111101111",
    "1111100211",
    "1111111111",
    [Present1, Present2, Present3, Present4]
    ]

    #past2.
    stage7=[
    "1111111111",
    "1200111111",
    "1113001111",
    "1101100011",
    "1100011011",
    "1111000011",
    "1111111111",
    [Past1, Past2, Past3, Past4]
    ]

    #space2
    # stage8=[
    # "11111111111111111111",
    # "11110000001200001011",
    # "11111101111111100011",
    # "11100101000111110111",
    # "11110030010110000111",
    # "11100101110010110111",
    # "11111100011000110011",
    # "11111111011010111011",
    # "11111111000010001011",
    # "11111111111111111111",
    # [Space1, Space2, Space3, Space4]
    # ]
    stage8=[
    "11111111111111111111",
    "11110000001200001011",
    "11111101111111100011",
    "11100101000111110111",
    "11110030010110000111",
    "11100101110010110111",
    "11111100011000110011",
    "11111111011010111011",
    "11111111000010001011",
    "11111111111111111111",
    [Space1, Space2, Space3, Space4]
    ]
    
label dungeon:
    
    $ event_check=False
    $ config.rollback_enabled=False
    while 1:
        python:
            # Calculate relative coordinate
            turnback=Position(here.map,here.y,here.x,-here.dy,-here.dx, here.num)
            turnright=Position(here.map,here.y,here.x,here.dx,-here.dy, here.num)
            turnleft=Position(here.map,here.y, here.x,-here.dx,here.dy, here.num)
            right1=Position(here.map,here.y+here.dx,here.x-here.dy,here.dy,here.dx, here.num)
            left1=Position(here.map,here.y-here.dx,here.x+here.dy,here.dy,here.dx, here.num)
            front1=Position(here.map,here.y+here.dy,here.x+here.dx, here.dy,here.dx, here.num)
            right2=Position(front1.map,front1.y+front1.dx,front1.x-front1.dy,front1.dy,front1.dx, here.num)
            left2=Position(front1.map,front1.y-front1.dx,front1.x+front1.dy,front1.dy,front1.dx, here.num)
            front2=Position(front1.map,front1.y+front1.dy,front1.x+front1.dx, front1.dy,front1.dx, here.num)
            right3=Position(front2.map,front2.y+front2.dx,front2.x-front2.dy,front2.dy,front2.dx, here.num)
            left3=Position(front2.map,front2.y-front2.dx,front2.x+front2.dy,front2.dy,front2.dx, here.num)
            
            # Composite background images. Try-except clauses are used to prevent the List Out of Index Error
            renpy.scene()
            
            renpy.show(img_pref+"base")
            try:
                if left3.map[left3.y][left3.x]=="1": renpy.show(img_pref+"left3")
            except:
                pass
            try:
                if right3.map[right3.y][right3.x]=="1": renpy.show(img_pref+"right3")
            except:
                pass
            try:
                if front2.map[front2.y][front2.x]=="1": renpy.show(img_pref+"front2")
            except:
                pass
            try:
                if left2.map[left2.y][left2.x]=="1": renpy.show(img_pref+"left2")
            except:
                pass
            try:
                if right2.map[right2.y][right2.x]=="1": renpy.show(img_pref+"right2")
            except:
                pass
            try:
                if front1.map[front1.y][front1.x]=="1": renpy.show(img_pref+"front1")
            except:
                pass
            try:
                if left1.map[left1.y][left1.x]=="1":  renpy.show(img_pref+"left1")
            except:
                pass
            try:
                if right1.map[right1.y][right1.x]=="1": renpy.show(img_pref+"right1")
            except:
                pass

            try:
                if front2.map[front2.y][front2.x]=="2": renpy.show("exit2")
            except:
                pass

            try:
                if front1.map[front1.y][front1.x]=="2": renpy.show("exit1")
            except:
                pass
                
            #exit maze events:
            if here.map[here.y][here.x]=="2":
                renpy.jump("exit_dungeon_"+str(here.num))

            #if here.x==1 and here.y==4:
                #renpy.jump("exit1")

            #other events:

            if here.map[here.y][here.x]=="a":
                renpy.jump("event_a")

                
            # loot events:
            # item = here.map[here.y][here.x]
            # if item=="N" or item=="C" or item=="T" or item=="L" or item=="B" or item=="C":
                # here.map = here.map.replace(item,"0")
                # renpy.jump("loot_"+item)
                
            if event_check and here.num>1 and renpy.random.random()<0.06:
                loot_items = ["N", "C", "T", "L", "B", "C"]
                random.shuffle(loot_items)
                for item in loot_items:
                    renpy.jump("loot_"+item)

            if event_check and not here.map[-1] == [] and renpy.random.random()<encounter_chance:
                renpy.jump("battle")
                
            # Check events and jump if happens
            if event_check and not here.map[-1] == [] and renpy.random.random()<encounter_chance:
                renpy.jump("battle")

            # Else, call the move screen
            event_check = True
            
            res = renpy.call_screen("move")
            if isinstance(res, Item):
                item = res
                if item.hp>0:
                    item.player.hp = item.player.hp+item.hp
                    inventory.drop(res)
                elif item.mp>0:
                    item.player.mp = item.player.mp+item.mp
                    inventory.drop(res)
                else:
                    Shoot.element=item.element
                renpy.hide_screen("inventory_screen")
                renpy.hide_screen("gui_tooltip")
                renpy.show_screen("move")
            else:
                here = res

label battle:
    $ renpy.music.set_volume(0.75, 2.5, channel="combat")
    $ enemy=copy(renpy.random.choice(here.map[-1])) # Copy monster instances not to modify the originals
    show screen battle_ui
    $ renpy.show(enemy.image)
    python:
        while enemy.hp>0:

            player.command(player, enemy)
            if enemy.hp<=0:
                break
            if dog.hp >0:
                dog.command(dog, enemy)

            if player.hp <1:
                renpy.music.play(DEFEAT, "sound")
                narrator ("Your consciousness is fading...")
                #reset the stuff for the next gameplay:
                # player.hp=player.max_hp
                # dog.hp=dog.max_hp
                # player.mp=player.max_mp
                # dog.mp=dog.max_mp
                # dog.dead = False
                renpy.full_restart()

    "You won!"
    $ renpy.music.set_volume(0.0, 2.5, channel="combat")
    play sound VICTORY
    $ renpy.hide(enemy.image)
    hide screen battle_ui
    python:
        if event_check and renpy.random.random()<0.5:
            loot_items = ["N", "C", "T", "L", "B", "C"]
            random.shuffle(loot_items)
            for item in loot_items:
                renpy.jump("loot_"+item)

    if special_battle:
        $ special_battle = False
        return
    jump dungeon
    
init -3 python:
    # Import the copy module for copying instances.
    from copy import copy
    
    # Class used for relative coodinate
    class Position():
        def __init__(self,map,y,x,dy,dx,num=0):
            self.map=map
            self.y=y
            self.x=x
            self.dy=dy
            self.dx=dx
            self.num=num
            
    # Class used for battle skills
    class Skill():
        def __init__(self, name, hit, power, type="attack", element="", mp=0):
            self.name = name
            self.mp = mp
            self.hit = hit
            self.power = power
            self.type = type
            self.element = element
            
    # Class used for battle characters. Inherit renpy.store.object for the rollback function.
    class Actor(renpy.store.object):
        def __init__(self, name, max_hp=0, skills=[], image="", weak="", max_mp=0):
            self.name=name
            self.max_hp=max_hp
            self.hp=max_hp
            self.skills = skills
            self.image = image
            self.weak = weak
            self.defending = False
            self.dead = False
            self.max_mp=max_mp
            self.mp=max_mp
            
        def command(self, who, target):
            who.defending = False
            
            self.skill = renpy.call_screen("command", char=who)
            target.skill = renpy.random.choice(target.skills)
            if self.skill.type=="attack":
                self.attack(self.skill, target)
                
                #narrator ("{} / {} ".format(self.skill.element,self.skill.name))
            # elif self.skill.type=="heal":
                # self.heal(self.skill)
            elif self.skill.type=="inventory":
                self.inventory_skill()
            elif self.skill.type=="defend":
                self.defend()
#                self.defending = True
            if target.hp < 1:
                return
            target.attack(target.skill, self)
            
        def attack(self,skill,target):
            if self.skill.hit<renpy.random.randint (0,100):
                narrator ("{} dodged {}'s attack!".format(target.name,self.name))
            else:
                if self.skill.mp>0:
                    self.mp -= self.skill.mp
                damage = self.skill.power
                
                #narrator ("{} / {} / {}".format(Shoot.element,skill.element,target.weak))
                
                #if self.skill.element == target.weak:
                
                if skill.name=="Shoot":
                    if Shoot.element == target.weak:
                        damage = int(damage * 2)
                    else:
                        damage = int(damage * 0.5)
                    
                if target.defending:
                    damage = int(damage / 2)
                target.hp -= damage
#                narrator ("{} got {} damage".format(target.name, self.skill.power))
                narrator ("{} took {} damage.".format(target.name, damage))
                
                if not dog.dead and dog.hp <= 0:
                    renpy.music.play(DEFEAT, "sound")
                    dog.dead = True
                    narrator ("{} has been knocked out.".format(target.name))

        # def heal(self, skill):
            # self.hp += self.skill.power

        def inventory_skill(self):
            item = renpy.call_screen("inventory_screen")
            if isinstance(item, Item):
                if item.hp>0:
                    item.player.hp = item.player.hp+item.hp
                    inventory.drop(item)
                elif item.mp>0:
                    item.player.mp = item.player.mp+item.mp
                    inventory.drop(item)
                else:
                    Shoot.element=item.element
                    # item.player.skills.remove(Shoot)
                    # item.player.skills.append(Shoot)
                    
                    #item.player.skills.Shoot.element=item.element
                    # for n,i in enumerate(item.player.skills):
                        # if i==Shoot:
                            # a[n]=Shoot

                    
                renpy.hide_screen("inventory_screen")
                renpy.hide_screen("gui_tooltip")
            
            #renpy.show_screen("inventory_screen")
            #renpy.show_menu("inventory_screen")

        def defend(self):
            narrator ("{} defends.".format(self.name))
            self.defending = True
            
init:
    # Screen used for moving
    screen move:
        fixed:
            if move_keys_visible:
                if front1.map[front1.y][front1.x] is not "1":
                    textbutton "^" action Return(value=front1)  xcenter .5 ycenter .34 # background Frame("gui/frame.png",24,24) ypadding 10 xpadding 20 text_color "#000" # hover_text_color "#FFF"
                textbutton ">" action Return(value=turnright) xcenter .57 ycenter .47 #background Frame("gui/frame.png",24,24) ypadding 10 xpadding 20
                textbutton "v" action Return(value=turnback) xcenter .5 ycenter .6 #background Frame("gui/frame.png",24,24) ypadding 10 xpadding 20
                textbutton "<" action Return(value=turnleft) xcenter .43 ycenter .47 #background Frame("gui/frame.png",24,24) ypadding 10 xpadding 20
                $ move_keys_visible_text = "Hide controls"
            else:
                $ move_keys_visible_text = "Show controls"

            if front1.map[front1.y][front1.x] is not "1":
                key "K_UP" action Return(value=front1)
                key "w" action Return(value=front1)
            key "K_LEFT" action Return(value=turnleft)
            key "a" action Return(value=turnright) 
            key "K_DOWN" action Return(value=turnback) 
            key "s" action Return(value=turnback) 
            key "K_RIGHT" action Return(value=turnright) 
            key "d" action Return(value=turnleft) 
            
            hbox align (.95,.04) spacing 20:
                if not renpy.variant("touch"):
                    textbutton move_keys_visible_text action ToggleVariable("move_keys_visible", true_value=True, false_value=False)
                textbutton "Show Inventory" action [ Hide("move"), Show("inventory_screen")]
            
            

    # Screen used for selecting skills
    screen command:
        vbox align (.75,.5):
            text "[char.name]" size 45
            for i in char.skills:
                if char.mp>=i.mp:
                    textbutton "[i.name]" size_group "commands" action Return (value=i)
                        
    # Screen which shows battle status
    screen battle_ui:
#        use battle_frame(char=player, position=(.95,.05))
#        use battle_frame(char=dog, position=(.95,.60))
        use battle_frame(char=player, position=(.97,.20))
        use battle_frame(char=dog, position=(.97,.50))
        use battle_frame(char=enemy, position=(.05,.20))
        

        
    screen battle_frame:
        frame area (0, 0, 270, 160) align position background Frame("gui/frame.png", 22, 22) left_padding 20 right_padding 20:
        
            vbox yfill True:
                text "[char.name]" outlines  [(1, "00000020", 0, 0)] color "#000"
                hbox xfill True:
                    text "HP " outlines  [(1, "00000020", 0, 0)] color "#000"
                    text "[char.hp]/[char.max_hp]" xalign 1.0 outlines  [(1, "00000020", 0, 0)] color "#000"
            if char.mp>0:
                vbox yfill True  ypos 110:
                    hbox xfill True:
                        text "EN " outlines  [(1, "00000020", 0, 0)] color "#000"
                        text "[char.mp]/[char.max_mp]" xalign 1.0 outlines  [(1, "00000020", 0, 0)] color "#000"

init:
    transform fly:
        parallel:
            anchor(0.0,0.0)
            #xpos 0.555
            xpos 0.255
            alpha 0.5
            #easeout 0.2 alpha 1.0 xpos 0.55
            easeout 0.2 alpha 1.0 xpos 0.25
            on hide:
                ease 0.2 alpha 0.0
        parallel:
            ypos -0.01
            ease 2.0 ypos 0.01
            ease 2.0 ypos -0.01
            repeat

    #Assign background images.
    
    image s_base = "crawler/s_base.png"
    image s_left1 = "crawler/s_left1.png"
    image s_right1 = im.Flip("crawler/s_left1.png", horizontal=True)
    image s_front1 = "crawler/s_front1.png"
    image s_left2 = "crawler/s_left2.png"
    image s_right2 = im.Flip("crawler/s_left2.png", horizontal=True)
    image s_front2 ="crawler/s_front2.png"
    image s_left3 = "crawler/s_left3.png"
    image s_right3 = im.Flip("crawler/s_left3.png", horizontal=True)
    
    image p_base = "crawler/p_base.png"
    image p_left1 = "crawler/p_left1.png"
    image p_right1 = im.Flip("crawler/p_left1.png", horizontal=True)
    image p_front1 = "crawler/p_front1.png"
    image p_left2 = "crawler/p_left2.png"
    image p_right2 = im.Flip("crawler/p_left2.png", horizontal=True)
    image p_front2 ="crawler/p_front2.png"
    image p_left3 = "crawler/p_left3.png"
    image p_right3 = im.Flip("crawler/p_left3.png", horizontal=True)

    image f_base = "crawler/f_base.png"
    image f_left1 = "crawler/f_left1.png"
    image f_right1 = im.Flip("crawler/f_left1.png", horizontal=True)
    image f_front1 = "crawler/f_front1.png"
    image f_left2 = "crawler/f_left2.png"
    image f_right2 = im.Flip("crawler/f_left2.png", horizontal=True)
    image f_front2 ="crawler/f_front2.png"
    image f_left3 = "crawler/f_left3.png"
    image f_right3 = im.Flip("crawler/f_left3.png", horizontal=True)

    image r_base = "crawler/r_base.png"
    image r_left1 = "crawler/r_left1.png"
    image r_right1 = im.Flip("crawler/r_left1.png", horizontal=True)
    image r_front1 = "crawler/r_front1.png"
    image r_left2 = "crawler/r_left2.png"
    image r_right2 = im.Flip("crawler/r_left2.png", horizontal=True)
    image r_front2 ="crawler/r_front2.png"
    image r_left3 = "crawler/r_left3.png"
    image r_right3 = im.Flip("crawler/r_left3.png", horizontal=True)
    
    
    
    image exit1:
        contains:
            "crawler/exit1.png"
        exit_hover
    image exit2:
        contains:
            "crawler/exit2.png"
        exit_hover

init:
    transform exit_hover:
        alpha 0.5
        parallel:
            anchor(0.5,0.5)
            ypos 0.5
            easeout 3.0 alpha 0.3
            easeout 3.0 alpha 0.5
            repeat
        parallel:
            ease 2.0 ypos 0.53
            ease 2.0 ypos 0.47
            repeat

    image enemy1_future:
        contains:
            "crawler/enemy1_future.png"
        fly
    image enemy1_past:
        contains:
            "crawler/enemy1_past.png"
        fly
    image enemy1_present:
        contains:
            "crawler/enemy1_present.png"
        fly
    image enemy1_space:
        contains:
            "crawler/enemy1_space.png"
        fly

    image enemy2_future: 
        contains:
            "crawler/enemy2_future.png"
        fly
    image enemy2_past:
        contains:
            "crawler/enemy2_past.png"
        fly
    image enemy2_present:
        contains:
            "crawler/enemy2_present.png"
        fly
    image enemy2_space:
        contains:
            "crawler/enemy2_space.png"
        fly
        
    image enemy3_future: 
        contains:
            "crawler/enemy3_future.png"
        fly
    image enemy3_past:
        contains:
            "crawler/enemy3_past.png"
        fly
    image enemy3_present:
        contains:
            "crawler/enemy3_present.png"
        fly
    image enemy3_space:
        contains:
            "crawler/enemy3_space.png"
        fly

    image enemy4_future: 
        contains:
            "crawler/enemy4_future.png"
        fly
    image enemy4_past:
        contains:
            "crawler/enemy4_past.png"
        fly
    image enemy4_present:
        contains:
            "crawler/enemy4_present.png"
        fly
    image enemy4_space:
        contains:
            "crawler/enemy4_space.png"
        fly
        
        
    #image enemy1_special = "crawler/enemy1_special.png"
    
    image enemyb1_future:
        "crawler/enemyb1_future.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb3_future.png" with Dissolve(3.0, alpha=True)
        3.0
        repeat
    image enemyb2_future:
        "crawler/enemyb2_future.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb4_future.png" with Dissolve(3.0, alpha=True)
        3.0
    image enemyb1_past:
        "crawler/enemyb1_past.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb3_past.png" with Dissolve(3.0, alpha=True)
        3.0
    image enemyb2_past:
        "crawler/enemyb2_past.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb4_past.png" with Dissolve(3.0, alpha=True)
        3.0
        
    image enemyb1_present:
        "crawler/enemyb1_present.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb3_present.png" with Dissolve(3.0, alpha=True)
        3.0
    image enemyb2_present:
        "crawler/enemyb2_present.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb4_present.png" with Dissolve(3.0, alpha=True)
        3.0
    image enemyb1_space:
        "crawler/enemyb1_space.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb3_space.png" with Dissolve(3.0, alpha=True)
        3.0
    image enemyb2_space:
        "crawler/enemyb2_space.png" with Dissolve(3.0, alpha=True)
        6.0
        "crawler/enemyb4_space.png" with Dissolve(3.0, alpha=True)
        3.0
    
    # Here is a visualised relative coordinate in this code. Image here=player and facing top.
    # left3, front2, right3
    # left2, front1, right2
    # left1,  here , right1  

init +1:
    
    image present_dungeon = im.Composite (None, (0,0), ImageReference("r_base"), (0,0), ImageReference("r_left3"), (0,0), ImageReference("r_right3"), (0,0),ImageReference("r_left1"), (0,0),ImageReference("r_right1"))
    image past_dungeon = im.Composite (None, (0,0), ImageReference("p_base"), (0,0), ImageReference("p_left3"), (0,0), ImageReference("p_right3"), (0,0),ImageReference("p_left1"), (0,0),ImageReference("p_right1"))
    image future_dungeon = im.Composite (None, (0,0), ImageReference("f_base"), (0,0), ImageReference("f_left3"), (0,0), ImageReference("f_right3"), (0,0),ImageReference("f_left1"), (0,0),ImageReference("f_right1"))
    image space_dungeon = im.Composite (None, (0,0), ImageReference("s_base"), (0,0), ImageReference("s_left3"), (0,0), ImageReference("s_right3"), (0,0),ImageReference("s_left1"), (0,0),ImageReference("s_right1"))
    
init -2 python:
    class Item(store.object):
        def __init__(self, name, space=0, player=None, cost=0, hp=0, mp=0, element="", image=""):
            self.name = name
            self.space=space
            self.player=player
            self.cost = cost
            self.hp = hp
            self.mp = mp
            self.element=element
            self.image=image

    class Inventory(store.object):
        def __init__(self, money=10):
            self.money = money
            self.items = []

        def add(self, item):
            # if len(self.items)>8:
                # narrator ("Your inventory is full!")
            # else:
            self.items.append(item)

        def drop(self, item):
            self.items.remove(item)

screen inventory_screen:    
    add "gui/inventory.png"    
    modal True
    use battle_frame(char=player, position=(.97,.20))
    use battle_frame(char=dog, position=(.97,.50))
    hbox align (.95,.04) spacing 20:
        textbutton "Close Inventory" action [ Hide("inventory_screen"), Return(here)]
        
    # $inventory.add(muskete)
    # $inventory.add(gun)        
    # $inventory.add(chips)
    # $inventory.add(cola)
    # $inventory.add(banana)
    # $inventory.add(treat)

        
    $ x = 515
    $ y = 25
    $ i = 0
    $ sorted_items = sorted(inventory.items, key=attrgetter('element'), reverse=True) #guns first
    
    $ next_inv_page = inv_page + 1            
    if next_inv_page > int(len(inventory.items)/9):
        $ next_inv_page = 0
    
    for item in sorted_items: #inventory.items:
        
        if i+1 <= (inv_page+1)*9 and i+1>inv_page*9:
            $ x += 190
            if i%3==0:
                $ y += 170
                $ x = 515
            $ pic = item.image
            $ my_tooltip = "tooltip_inventory_" + pic.replace("gui/inv_", "").replace(".png", "")
            imagebutton idle pic hover pic xpos x ypos y action [Hide("gui_tooltip"), Return(item)] hovered [ Play ("sound", "sfx/click.wav"), Show("gui_tooltip", my_picture=my_tooltip, my_tt_ypos=693) ] unhovered [Hide("gui_tooltip")] at inv_eff
            if Shoot.element and (Shoot.element==item.element): #indicate the selected gun
                add "gui/selected.png" xpos x ypos y anchor(.5,.5)
        $ i += 1
        if len(inventory.items)>9:
            textbutton _("Next Page") action [SetVariable('inv_page', next_inv_page), Show("inventory_screen")] xpos .475 ypos .83
        
init -2:
    transform inv_eff:
        zoom 0.5 xanchor 0.5 yanchor 0.5
        on idle:
            #easein 0.5 zoom 0.5
            linear 0.2 alpha 1.0
        # on selected_idle:
            # easein 0.5 zoom 0.5
        on hover:
            #easein 0.5 zoom 0.65
            linear 0.2 alpha 2.5
        # on selected_hover:
            # easein 0.5 zoom 0.65

    transform boss_kill:
        parallel:
            linear 0.1 xalign 0.54
            linear 0.1 xalign 0.43
            linear 0.05 xalign 0.45
            linear 0.05 xalign 0.55
            linear 0.1 xalign 0.59
            linear 0.1 xalign 0.44
            repeat
        parallel:
            linear 1.0 alpha 5.0
            linear 1.0 alpha 0.0
            
init python:
    showitems = False #turn True to debug the inventory
    def display_items_overlay():
        if showitems:
            inventory_show = "Inventory: "
            if current_item:
                inventory_show += current_item.name
            for i in range(0, len(inventory.items)):
                item_name = inventory.items[i].name
                if i > 0:
                    inventory_show += ", "
                inventory_show += item_name
            ui.frame()
            ui.text(inventory_show, color="#000")
    config.overlay_functions.append(display_items_overlay)
    
init python:
    def weaken_dog():
        Bite.power -= 3
        Scratch.power -= 2
        Charge.power -= 3
        dog.max_hp -= 5
        if dog.hp>dog.max_hp:
            dog.hp=dog.max_hp
        
label loot_N:
    $ inventory.add(banana)
    "You found a [banana.name]."
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
label loot_C:
    $ inventory.add(chocolate)
    "You found a [chocolate.name]. Sweet!"
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
label loot_T:
    $ inventory.add(treat)
    "You found a [treat.name]."
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
label loot_L:
    $ inventory.add(cola)
    "You found a bottle of [cola.name]."
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
label loot_B:
    $ inventory.add(bone)
    "You found an old [bone.name]."
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
label loot_H:
    $ inventory.add(chips)
    "You found some [chips.name]."
    if special_battle:
        $ special_battle = False
        return
    jump dungeon
    
    